import { Type } from '@angular/core';
import { NgModuleRef } from '@angular/core';
import 'reflect-metadata';
import { ICommand, ICommandBus, ICommandHandler, ICommandPublisher } from './interfaces/index';
import { ObservableBus } from './utils/observable-bus';
import * as i0 from "@angular/core";
export declare type CommandHandlerType = Type<ICommandHandler<ICommand>>;
export declare class CommandBus<CommandBase extends ICommand = ICommand> extends ObservableBus<CommandBase> implements ICommandBus<CommandBase> {
    private readonly moduleRef;
    private handlers;
    private _publisher;
    constructor(moduleRef: NgModuleRef<any>);
    get publisher(): ICommandPublisher<CommandBase>;
    set publisher(_publisher: ICommandPublisher<CommandBase>);
    execute<T extends CommandBase, R = any>(command: T): Promise<R>;
    bind<T extends CommandBase>(handler: ICommandHandler<T>, id: string): void;
    register(handlers?: CommandHandlerType[]): void;
    protected registerHandler(handler: CommandHandlerType): void;
    private getCommandId;
    private reflectCommandId;
    private useDefaultPublisher;
    static ɵfac: i0.ɵɵFactoryDeclaration<CommandBus<any>, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<CommandBus<any>>;
}
