import { Type } from '@angular/core';
import { NgModuleRef } from '@angular/core';
import 'reflect-metadata';
import { Observable } from 'rxjs';
import { IQuery, IQueryBus, IQueryHandler, IQueryPublisher, IQueryResult } from './interfaces';
import { ObservableBus } from './utils/observable-bus';
import * as i0 from "@angular/core";
export declare type QueryHandlerType<QueryBase extends IQuery = IQuery, QueryResultBase extends IQueryResult = IQueryResult> = Type<IQueryHandler<QueryBase, QueryResultBase>>;
export declare class QueryBus<QueryBase extends IQuery = IQuery> extends ObservableBus<QueryBase> implements IQueryBus<QueryBase> {
    private readonly moduleRef;
    private handlers;
    private _publisher;
    constructor(moduleRef: NgModuleRef<any>);
    get publisher(): IQueryPublisher<QueryBase>;
    set publisher(_publisher: IQueryPublisher<QueryBase>);
    execute<T extends QueryBase, TResult = any>(query: T): Observable<TResult>;
    bind<T extends QueryBase, TResult = any>(handler: IQueryHandler<T, TResult>, queryId: string): void;
    register(handlers?: QueryHandlerType<QueryBase>[]): void;
    protected registerHandler(handler: QueryHandlerType<QueryBase>): void;
    private getQueryId;
    private reflectQueryId;
    private useDefaultPublisher;
    static ɵfac: i0.ɵɵFactoryDeclaration<QueryBus<any>, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<QueryBus<any>>;
}
