import { Type } from '@angular/core';
import { IEvent } from '../interfaces';
import { NgModuleRef, NgModule } from '@angular/core';
import { InjectionToken } from '@angular/core';
import { CommandBus } from '../command-bus';
import { EventBus } from '../event-bus';
import { QueryBus } from '../query-bus';
import * as i0 from "@angular/core";
export declare const PROVIDERS: InjectionToken<unknown>;
export declare class BindService<EventBase extends IEvent = IEvent> {
    private readonly moduleRef;
    private readonly eventsBus;
    private readonly commandsBus;
    private readonly queryBus;
    constructor(moduleRef: NgModuleRef<NgModule>, eventsBus: EventBus<EventBase>, commandsBus: CommandBus, queryBus: QueryBus);
    private _explored;
    get explored(): boolean;
    bind(): void;
    flatMap<T>(providers: any, callback: (instance: any) => Type<any> | undefined): Type<T>[];
    filterProvider(instance: any, metadataKey: string): Type<any> | undefined;
    extractMetadata(instance: Record<string, any>, metadataKey: string): Type<any>;
    static ɵfac: i0.ɵɵFactoryDeclaration<BindService<any>, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<BindService<any>>;
}
